/**
 * Copyright 2013 (c) Anna Schumaker.
 *
 * DO NOT INCLUDE THIS FILE DIRECTLY.  THIS IS A TEMPLATE DEFINITION FILE
 * AND ONLY MEANT TO BE INCLUDED BY include/idle.h!
 */
#ifndef OCARINA_IDLE_HPP
#define OCARINA_IDLE_HPP

template <class T>
idle :: IdleTask<T> :: IdleTask(void (*func)(T &), T data)
		     : _func(func), _data(data)
{
	IdleBase :: schedule();
}

template <class T>
idle :: IdleTask<T> :: ~IdleTask()
{
}

template <class T>
void idle :: IdleTask<T> :: run()
{
	_func(_data);
}

#endif /* OCARINA_IDLE_HPP */
