/**
 * Copyright 2014 (c) Anna Schumaker.
 */
#include <core/tags/album.h>
#include <core/tags/artist.h>
#include <core/tags/genre.h>
#include <core/tags/library.h>
#include <core/tags/tags.h>
#include <core/tags/track.h>

void tags :: init()
{
	album_db_init();
	artist_db_init();
	genre_db_init();
	library_db_init();
	track_db_init();
}

void tags :: deinit()
{
	track_db_deinit();
	library_db_deinit();
	genre_db_deinit();
	artist_db_deinit();
	album_db_deinit();
}
